require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_STAT_H)) {
    die("Never include <bits/stat.h> directly; use <sys/stat.h> instead.");
}
unless(defined(&_STAT_VER_KERNEL)) {
    sub _STAT_VER_KERNEL () {	0;}
}
unless(defined(&_STAT_VER_LINUX)) {
    sub _STAT_VER_LINUX () {	1;}
}
unless(defined(&_STAT_VER)) {
    sub _STAT_VER () {	 &_STAT_VER_LINUX;}
}
unless(defined(&_MKNOD_VER_LINUX)) {
    sub _MKNOD_VER_LINUX () {	0;}
}
if(defined(&__USE_MISC)) {
    eval 'sub st_atime () { ($st_atim->{tv_sec});}' unless defined(&st_atime);
    eval 'sub st_mtime () { ($st_mtim->{tv_sec});}' unless defined(&st_mtime);
    eval 'sub st_ctime () { ($st_ctim->{tv_sec});}' unless defined(&st_ctime);
} else {
}
if(defined(&__USE_LARGEFILE64)) {
    if(defined(&__USE_MISC)) {
	eval 'sub st_atime () { ($st_atim->{tv_sec});}' unless defined(&st_atime);
	eval 'sub st_mtime () { ($st_mtim->{tv_sec});}' unless defined(&st_mtime);
	eval 'sub st_ctime () { ($st_ctim->{tv_sec});}' unless defined(&st_ctime);
    } else {
    }
}
unless(defined(&_STATBUF_ST_BLKSIZE)) {
    sub _STATBUF_ST_BLKSIZE () {	1;}
}
unless(defined(&_STATBUF_ST_RDEV)) {
    sub _STATBUF_ST_RDEV () {	1;}
}
unless(defined(&_STATBUF_ST_NSEC)) {
    sub _STATBUF_ST_NSEC () {	1;}
}
unless(defined(&__S_IFMT)) {
    sub __S_IFMT () {	0170000;}
}
unless(defined(&__S_IFDIR)) {
    sub __S_IFDIR () {	0040000;}
}
unless(defined(&__S_IFCHR)) {
    sub __S_IFCHR () {	0020000;}
}
unless(defined(&__S_IFBLK)) {
    sub __S_IFBLK () {	0060000;}
}
unless(defined(&__S_IFREG)) {
    sub __S_IFREG () {	0100000;}
}
unless(defined(&__S_IFIFO)) {
    sub __S_IFIFO () {	0010000;}
}
unless(defined(&__S_IFLNK)) {
    sub __S_IFLNK () {	0120000;}
}
unless(defined(&__S_IFSOCK)) {
    sub __S_IFSOCK () {	0140000;}
}
unless(defined(&__S_TYPEISMQ)) {
    sub __S_TYPEISMQ {
	my($buf) = @_;
	eval q((($buf)-> &st_mode - ($buf)-> &st_mode));
    }
}
unless(defined(&__S_TYPEISSEM)) {
    sub __S_TYPEISSEM {
	my($buf) = @_;
	eval q((($buf)-> &st_mode - ($buf)-> &st_mode));
    }
}
unless(defined(&__S_TYPEISSHM)) {
    sub __S_TYPEISSHM {
	my($buf) = @_;
	eval q((($buf)-> &st_mode - ($buf)-> &st_mode));
    }
}
unless(defined(&__S_ISUID)) {
    sub __S_ISUID () {	04000;}
}
unless(defined(&__S_ISGID)) {
    sub __S_ISGID () {	02000;}
}
unless(defined(&__S_ISVTX)) {
    sub __S_ISVTX () {	01000;}
}
unless(defined(&__S_IREAD)) {
    sub __S_IREAD () {	0400;}
}
unless(defined(&__S_IWRITE)) {
    sub __S_IWRITE () {	0200;}
}
unless(defined(&__S_IEXEC)) {
    sub __S_IEXEC () {	0100;}
}
if(defined (defined(&__USE_ATFILE) ? &__USE_ATFILE : 0) || defined (defined(&__USE_GNU) ? &__USE_GNU : 0)) {
    eval 'sub UTIME_NOW () {((1 << 30) - 1);}' unless defined(&UTIME_NOW);
    eval 'sub UTIME_OMIT () {((1 << 30) - 2);}' unless defined(&UTIME_OMIT);
}
1;
