require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__GMP_H__)) {
    if(defined ( &__cplusplus)) {
	require 'iosfwd';
    }
    if(! defined ( &__GMP_WITHIN_CONFIGURE)) {
	eval 'sub __GMP_BITS_PER_MP_LIMB () {64;}' unless defined(&__GMP_BITS_PER_MP_LIMB);
	eval 'sub __GMP_HAVE_HOST_CPU_FAMILY_power () {0;}' unless defined(&__GMP_HAVE_HOST_CPU_FAMILY_power);
	eval 'sub __GMP_HAVE_HOST_CPU_FAMILY_powerpc () {0;}' unless defined(&__GMP_HAVE_HOST_CPU_FAMILY_powerpc);
	eval 'sub GMP_LIMB_BITS () {64;}' unless defined(&GMP_LIMB_BITS);
	eval 'sub GMP_NAIL_BITS () {0;}' unless defined(&GMP_NAIL_BITS);
    }
    eval 'sub GMP_NUMB_BITS () {( &GMP_LIMB_BITS -  &GMP_NAIL_BITS);}' unless defined(&GMP_NUMB_BITS);
    eval 'sub GMP_NUMB_MASK () {((~  &__GMP_CAST ( &mp_limb_t, 0)) >>  &GMP_NAIL_BITS);}' unless defined(&GMP_NUMB_MASK);
    eval 'sub GMP_NUMB_MAX () { &GMP_NUMB_MASK;}' unless defined(&GMP_NUMB_MAX);
    eval 'sub GMP_NAIL_MASK () {(~  &GMP_NUMB_MASK);}' unless defined(&GMP_NAIL_MASK);
    unless(defined(&__GNU_MP__)) {
	eval 'sub __GNU_MP__ () {4;}' unless defined(&__GNU_MP__);
	eval 'sub __need_size_t () {1;}' unless defined(&__need_size_t);
	if(defined ( &__cplusplus)) {
	    require 'cstddef';
	} else {
	    require 'stddef.ph';
	}
	undef(&__need_size_t) if defined(&__need_size_t);
	if(! defined ( &__GMP_WITHIN_CONFIGURE)) {
	    eval 'sub __GMP_LIBGMP_DLL () {0;}' unless defined(&__GMP_LIBGMP_DLL);
	}
	if(defined ( &__STDC__) || defined ( &__cplusplus) || defined ( &_AIX) || defined ( &__DECC) || (defined ( &__mips)  && defined ( &_SYSTYPE_SVR4)) || defined ( &_MSC_VER) || defined ( &_WIN32)) {
	    eval 'sub __GMP_HAVE_CONST () {1;}' unless defined(&__GMP_HAVE_CONST);
	    eval 'sub __GMP_HAVE_PROTOTYPES () {1;}' unless defined(&__GMP_HAVE_PROTOTYPES);
	    eval 'sub __GMP_HAVE_TOKEN_PASTE () {1;}' unless defined(&__GMP_HAVE_TOKEN_PASTE);
	} else {
	    eval 'sub __GMP_HAVE_CONST () {0;}' unless defined(&__GMP_HAVE_CONST);
	    eval 'sub __GMP_HAVE_PROTOTYPES () {0;}' unless defined(&__GMP_HAVE_PROTOTYPES);
	    eval 'sub __GMP_HAVE_TOKEN_PASTE () {0;}' unless defined(&__GMP_HAVE_TOKEN_PASTE);
	}
	if((defined(&__GMP_HAVE_CONST) ? &__GMP_HAVE_CONST : 0)) {
	    eval 'sub __gmp_const () { &const;}' unless defined(&__gmp_const);
	    eval 'sub __gmp_signed () {\'signed\';}' unless defined(&__gmp_signed);
	} else {
	    eval 'sub __gmp_const () {1;}' unless defined(&__gmp_const);
	    eval 'sub __gmp_signed () {1;}' unless defined(&__gmp_signed);
	}
	if(defined ( &__GNUC__)) {
	    eval 'sub __GMP_DECLSPEC_EXPORT () { &__declspec( &__dllexport__);}' unless defined(&__GMP_DECLSPEC_EXPORT);
	    eval 'sub __GMP_DECLSPEC_IMPORT () { &__declspec( &__dllimport__);}' unless defined(&__GMP_DECLSPEC_IMPORT);
	}
	if(defined ( &_MSC_VER) || defined ( &__BORLANDC__)) {
	    eval 'sub __GMP_DECLSPEC_EXPORT () { &__declspec( &dllexport);}' unless defined(&__GMP_DECLSPEC_EXPORT);
	    eval 'sub __GMP_DECLSPEC_IMPORT () { &__declspec( &dllimport);}' unless defined(&__GMP_DECLSPEC_IMPORT);
	}
	if(defined(&__WATCOMC__)) {
	    eval 'sub __GMP_DECLSPEC_EXPORT () { &__export;}' unless defined(&__GMP_DECLSPEC_EXPORT);
	    eval 'sub __GMP_DECLSPEC_IMPORT () { &__import;}' unless defined(&__GMP_DECLSPEC_IMPORT);
	}
	if(defined(&__IBMC__)) {
	    eval 'sub __GMP_DECLSPEC_EXPORT () { &_Export;}' unless defined(&__GMP_DECLSPEC_EXPORT);
	    eval 'sub __GMP_DECLSPEC_IMPORT () { &_Import;}' unless defined(&__GMP_DECLSPEC_IMPORT);
	}
	if((defined(&__GMP_LIBGMP_DLL) ? &__GMP_LIBGMP_DLL : 0)) {
	    if((defined(&__GMP_WITHIN_GMP) ? &__GMP_WITHIN_GMP : 0)) {
		eval 'sub __GMP_DECLSPEC () { &__GMP_DECLSPEC_EXPORT;}' unless defined(&__GMP_DECLSPEC);
	    } else {
		eval 'sub __GMP_DECLSPEC () { &__GMP_DECLSPEC_IMPORT;}' unless defined(&__GMP_DECLSPEC);
	    }
	} else {
	    eval 'sub __GMP_DECLSPEC () {1;}' unless defined(&__GMP_DECLSPEC);
	}
	if(defined(&__GMP_SHORT_LIMB)) {
	} else {
	    if(defined(&_LONG_LONG_LIMB)) {
	    } else {
	    }
	}
    }
    if(defined ( &_CRAY)  && ! defined ( &_CRAYMPP)) {
	eval 'sub __GMP_MP_SIZE_T_INT () {1;}' unless defined(&__GMP_MP_SIZE_T_INT);
    } else {
	eval 'sub __GMP_MP_SIZE_T_INT () {0;}' unless defined(&__GMP_MP_SIZE_T_INT);
    }
    eval("sub GMP_RAND_ALG_DEFAULT () { 0; }") unless defined(&GMP_RAND_ALG_DEFAULT);
    eval("sub GMP_RAND_ALG_LC () { GMP_RAND_ALG_DEFAULT; }") unless defined(&GMP_RAND_ALG_LC);
    if((defined(&__GMP_LIBGMP_DLL) ? &__GMP_LIBGMP_DLL : 0)) {
	if((defined(&__GMP_WITHIN_GMPXX) ? &__GMP_WITHIN_GMPXX : 0)) {
	    eval 'sub __GMP_DECLSPEC_XX () { &__GMP_DECLSPEC_EXPORT;}' unless defined(&__GMP_DECLSPEC_XX);
	} else {
	    eval 'sub __GMP_DECLSPEC_XX () { &__GMP_DECLSPEC_IMPORT;}' unless defined(&__GMP_DECLSPEC_XX);
	}
    } else {
	eval 'sub __GMP_DECLSPEC_XX () {1;}' unless defined(&__GMP_DECLSPEC_XX);
    }
    if((defined(&__GMP_HAVE_PROTOTYPES) ? &__GMP_HAVE_PROTOTYPES : 0)) {
	eval 'sub __GMP_PROTO {
	    my($x) = @_;
    	    eval q($x);
	}' unless defined(&__GMP_PROTO);
    } else {
	eval 'sub __GMP_PROTO {
	    my($x) = @_;
    	    eval q(());
	}' unless defined(&__GMP_PROTO);
    }
    unless(defined(&__MPN)) {
	if((defined(&__GMP_HAVE_TOKEN_PASTE) ? &__GMP_HAVE_TOKEN_PASTE : 0)) {
	    eval 'sub __MPN {
	        my($x) = @_;
    		eval q( &__gmpn_$x);
	    }' unless defined(&__MPN);
	} else {
	    eval 'sub __MPN {
	        my($x) = @_;
    		eval q( &__gmpn_ $x);
	    }' unless defined(&__MPN);
	}
    }
    if(defined  || defined ( &H_STDIO) || defined ( &_H_STDIO) || defined ( &_STDIO_H) || defined ( &_STDIO_H_) || defined ( &__STDIO_H) || defined ( &__STDIO_H__) || defined ( &_STDIO_INCLUDED) || defined ( &__dj_include_stdio_h_) || defined ( &_FILE_DEFINED) || defined ( &__STDIO__) || defined ( &_MSL_STDIO_H) || defined ( &_STDIO_H_INCLUDED) || defined ( &_ISO_STDIO_ISO_H) ) {
	eval 'sub _GMP_H_HAVE_FILE () {1;}' unless defined(&_GMP_H_HAVE_FILE);
    }
    if(defined ( &_OBSTACK_H) ) {
	eval 'sub _GMP_H_HAVE_OBSTACK () {1;}' unless defined(&_GMP_H_HAVE_OBSTACK);
    }
    if(defined(&va_start)) {
	eval 'sub _GMP_H_HAVE_VA_LIST () {1;}' unless defined(&_GMP_H_HAVE_VA_LIST);
    }
    if(defined ( &__GNUC__)  && defined ( &__GNUC_MINOR__)) {
	eval 'sub __GMP_GNUC_PREREQ {
	    my($maj, $min) = @_;
    	    eval q((( &__GNUC__ << 16) +  &__GNUC_MINOR__ >= (($maj) << 16) + ($min)));
	}' unless defined(&__GMP_GNUC_PREREQ);
    } else {
	eval 'sub __GMP_GNUC_PREREQ {
	    my($maj, $min) = @_;
    	    eval q(0);
	}' unless defined(&__GMP_GNUC_PREREQ);
    }
    if( &__GMP_GNUC_PREREQ (2,96)  && ! defined ( &__GMP_NO_ATTRIBUTE_CONST_PURE)) {
	eval 'sub __GMP_ATTRIBUTE_PURE () { &__attribute__ (( &__pure__));}' unless defined(&__GMP_ATTRIBUTE_PURE);
    } else {
	eval 'sub __GMP_ATTRIBUTE_PURE () {1;}' unless defined(&__GMP_ATTRIBUTE_PURE);
    }
    if(defined(&__cplusplus)) {
	eval 'sub __GMP_CAST {
	    my($type, $expr) = @_;
    	    eval q(( &static_cast<$type> ($expr)));
	}' unless defined(&__GMP_CAST);
    } else {
	eval 'sub __GMP_CAST {
	    my($type, $expr) = @_;
    	    eval q((($type) ($expr)));
	}' unless defined(&__GMP_CAST);
    }
    if(defined ( &__cplusplus)) {
	eval 'sub __GMP_NOTHROW () { &throw ();}' unless defined(&__GMP_NOTHROW);
    } else {
	eval 'sub __GMP_NOTHROW () {1;}' unless defined(&__GMP_NOTHROW);
    }
    if(defined(&__GNUC__)) {
	if(defined(&__GNUC_STDC_INLINE__)) {
	    eval 'sub __GMP_EXTERN_INLINE () { &extern  &__inline__  &__attribute__ (( &__gnu_inline__));}' unless defined(&__GMP_EXTERN_INLINE);
	} else {
	    eval 'sub __GMP_EXTERN_INLINE () { &extern  &__inline__;}' unless defined(&__GMP_EXTERN_INLINE);
	}
	eval 'sub __GMP_INLINE_PROTOTYPES () {1;}' unless defined(&__GMP_INLINE_PROTOTYPES);
    }
    if(defined(&__DECC)) {
	eval 'sub __GMP_EXTERN_INLINE () { &static  &__inline;}' unless defined(&__GMP_EXTERN_INLINE);
    }
    if(defined(&__SCO_VERSION__)) {
	if((defined(&__SCO_VERSION__) ? &__SCO_VERSION__ : 0) > 400000000 && (defined(&__STDC__) ? &__STDC__ : 0) != 1 && ! defined ( &__GMP_EXTERN_INLINE)) {
	    eval 'sub __GMP_EXTERN_INLINE () { &static  &inline;}' unless defined(&__GMP_EXTERN_INLINE);
	}
    }
    if(defined ( &__cplusplus)  && ! defined ( &__GMP_EXTERN_INLINE)) {
	eval 'sub __GMP_EXTERN_INLINE () { &inline;}' unless defined(&__GMP_EXTERN_INLINE);
    }
    if(defined ( &__GMP_WITHIN_CONFIGURE)  && ! (defined(&__GMP_WITHIN_CONFIGURE_INLINE) ? &__GMP_WITHIN_CONFIGURE_INLINE : 0)) {
	undef(&__GMP_EXTERN_INLINE) if defined(&__GMP_EXTERN_INLINE);
    }
    if(defined(&__GMP_EXTERN_INLINE)) {
	unless(defined(&__GMP_INLINE_PROTOTYPES)) {
	    eval 'sub __GMP_INLINE_PROTOTYPES () {0;}' unless defined(&__GMP_INLINE_PROTOTYPES);
	}
    } else {
	eval 'sub __GMP_INLINE_PROTOTYPES () {1;}' unless defined(&__GMP_INLINE_PROTOTYPES);
    }
    eval 'sub __GMP_ABS {
        my($x) = @_;
	    eval q((($x) >= 0? ($x) : -($x)));
    }' unless defined(&__GMP_ABS);
    eval 'sub __GMP_MAX {
        my($h,$i) = @_;
	    eval q((($h) > ($i) ? ($h) : ($i)));
    }' unless defined(&__GMP_MAX);
    eval 'sub __GMP_UINT_MAX () {(~ 0);}' unless defined(&__GMP_UINT_MAX);
    eval 'sub __GMP_ULONG_MAX () {(~ 0);}' unless defined(&__GMP_ULONG_MAX);
    eval 'sub __GMP_USHRT_MAX () {( ~0);}' unless defined(&__GMP_USHRT_MAX);
    if( &__GMP_GNUC_PREREQ (3,0)) {
	eval 'sub __GMP_LIKELY {
	    my($cond) = @_;
    	    eval q( &__builtin_expect (($cond) != 0, 1));
	}' unless defined(&__GMP_LIKELY);
	eval 'sub __GMP_UNLIKELY {
	    my($cond) = @_;
    	    eval q( &__builtin_expect (($cond) != 0, 0));
	}' unless defined(&__GMP_UNLIKELY);
    } else {
	eval 'sub __GMP_LIKELY {
	    my($cond) = @_;
    	    eval q(($cond));
	}' unless defined(&__GMP_LIKELY);
	eval 'sub __GMP_UNLIKELY {
	    my($cond) = @_;
    	    eval q(($cond));
	}' unless defined(&__GMP_UNLIKELY);
    }
    if(defined(&_CRAY)) {
	eval 'sub __GMP_CRAY_Pragma {
	    my($str) = @_;
    	    eval q( &_Pragma ($str));
	}' unless defined(&__GMP_CRAY_Pragma);
    } else {
	eval 'sub __GMP_CRAY_Pragma {
	    my($str) = @_;
    	    eval q();
	}' unless defined(&__GMP_CRAY_Pragma);
    }
    eval 'sub mpq_numref {
        my($Q) = @_;
	    eval q(((($Q)-> &_mp_num)));
    }' unless defined(&mpq_numref);
    eval 'sub mpq_denref {
        my($Q) = @_;
	    eval q(((($Q)-> &_mp_den)));
    }' unless defined(&mpq_denref);
    if(defined ( &__cplusplus)) {
	if(defined(&_GMP_H_HAVE_FILE)) {
	}
    }
    eval 'sub mp_set_memory_functions () { &__gmp_set_memory_functions;}' unless defined(&mp_set_memory_functions);
    eval 'sub mp_get_memory_functions () { &__gmp_get_memory_functions;}' unless defined(&mp_get_memory_functions);
    eval 'sub mp_bits_per_limb () { &__gmp_bits_per_limb;}' unless defined(&mp_bits_per_limb);
    eval 'sub gmp_errno () { &__gmp_errno;}' unless defined(&gmp_errno);
    eval 'sub gmp_version () { &__gmp_version;}' unless defined(&gmp_version);
    eval 'sub gmp_randinit () { &__gmp_randinit;}' unless defined(&gmp_randinit);
    eval 'sub gmp_randinit_default () { &__gmp_randinit_default;}' unless defined(&gmp_randinit_default);
    eval 'sub gmp_randinit_lc_2exp () { &__gmp_randinit_lc_2exp;}' unless defined(&gmp_randinit_lc_2exp);
    eval 'sub gmp_randinit_lc_2exp_size () { &__gmp_randinit_lc_2exp_size;}' unless defined(&gmp_randinit_lc_2exp_size);
    eval 'sub gmp_randinit_mt () { &__gmp_randinit_mt;}' unless defined(&gmp_randinit_mt);
    eval 'sub gmp_randinit_set () { &__gmp_randinit_set;}' unless defined(&gmp_randinit_set);
    eval 'sub gmp_randseed () { &__gmp_randseed;}' unless defined(&gmp_randseed);
    eval 'sub gmp_randseed_ui () { &__gmp_randseed_ui;}' unless defined(&gmp_randseed_ui);
    eval 'sub gmp_randclear () { &__gmp_randclear;}' unless defined(&gmp_randclear);
    eval 'sub gmp_urandomb_ui () { &__gmp_urandomb_ui;}' unless defined(&gmp_urandomb_ui);
    eval 'sub gmp_urandomm_ui () { &__gmp_urandomm_ui;}' unless defined(&gmp_urandomm_ui);
    eval 'sub gmp_asprintf () { &__gmp_asprintf;}' unless defined(&gmp_asprintf);
    eval 'sub gmp_fprintf () { &__gmp_fprintf;}' unless defined(&gmp_fprintf);
    if(defined(&_GMP_H_HAVE_FILE)) {
    }
    eval 'sub gmp_obstack_printf () { &__gmp_obstack_printf;}' unless defined(&gmp_obstack_printf);
    if(defined ( &_GMP_H_HAVE_OBSTACK)) {
    }
    eval 'sub gmp_obstack_vprintf () { &__gmp_obstack_vprintf;}' unless defined(&gmp_obstack_vprintf);
    if(defined ( &_GMP_H_HAVE_OBSTACK)  && defined ( &_GMP_H_HAVE_VA_LIST)) {
    }
    eval 'sub gmp_printf () { &__gmp_printf;}' unless defined(&gmp_printf);
    eval 'sub gmp_snprintf () { &__gmp_snprintf;}' unless defined(&gmp_snprintf);
    eval 'sub gmp_sprintf () { &__gmp_sprintf;}' unless defined(&gmp_sprintf);
    eval 'sub gmp_vasprintf () { &__gmp_vasprintf;}' unless defined(&gmp_vasprintf);
    if(defined ( &_GMP_H_HAVE_VA_LIST)) {
    }
    eval 'sub gmp_vfprintf () { &__gmp_vfprintf;}' unless defined(&gmp_vfprintf);
    if(defined ( &_GMP_H_HAVE_FILE)  && defined ( &_GMP_H_HAVE_VA_LIST)) {
    }
    eval 'sub gmp_vprintf () { &__gmp_vprintf;}' unless defined(&gmp_vprintf);
    if(defined ( &_GMP_H_HAVE_VA_LIST)) {
    }
    eval 'sub gmp_vsnprintf () { &__gmp_vsnprintf;}' unless defined(&gmp_vsnprintf);
    if(defined ( &_GMP_H_HAVE_VA_LIST)) {
    }
    eval 'sub gmp_vsprintf () { &__gmp_vsprintf;}' unless defined(&gmp_vsprintf);
    if(defined ( &_GMP_H_HAVE_VA_LIST)) {
    }
    eval 'sub gmp_fscanf () { &__gmp_fscanf;}' unless defined(&gmp_fscanf);
    if(defined(&_GMP_H_HAVE_FILE)) {
    }
    eval 'sub gmp_scanf () { &__gmp_scanf;}' unless defined(&gmp_scanf);
    eval 'sub gmp_sscanf () { &__gmp_sscanf;}' unless defined(&gmp_sscanf);
    eval 'sub gmp_vfscanf () { &__gmp_vfscanf;}' unless defined(&gmp_vfscanf);
    if(defined ( &_GMP_H_HAVE_FILE)  && defined ( &_GMP_H_HAVE_VA_LIST)) {
    }
    eval 'sub gmp_vscanf () { &__gmp_vscanf;}' unless defined(&gmp_vscanf);
    if(defined ( &_GMP_H_HAVE_VA_LIST)) {
    }
    eval 'sub gmp_vsscanf () { &__gmp_vsscanf;}' unless defined(&gmp_vsscanf);
    if(defined ( &_GMP_H_HAVE_VA_LIST)) {
    }
    eval 'sub _mpz_realloc () { &__gmpz_realloc;}' unless defined(&_mpz_realloc);
    eval 'sub mpz_realloc () { &__gmpz_realloc;}' unless defined(&mpz_realloc);
    eval 'sub mpz_abs () { &__gmpz_abs;}' unless defined(&mpz_abs);
    if((defined(&__GMP_INLINE_PROTOTYPES) ? &__GMP_INLINE_PROTOTYPES : 0) || defined ( &__GMP_FORCE_mpz_abs)) {
    }
    eval 'sub mpz_add () { &__gmpz_add;}' unless defined(&mpz_add);
    eval 'sub mpz_add_ui () { &__gmpz_add_ui;}' unless defined(&mpz_add_ui);
    eval 'sub mpz_addmul () { &__gmpz_addmul;}' unless defined(&mpz_addmul);
    eval 'sub mpz_addmul_ui () { &__gmpz_addmul_ui;}' unless defined(&mpz_addmul_ui);
    eval 'sub mpz_and () { &__gmpz_and;}' unless defined(&mpz_and);
    eval 'sub mpz_array_init () { &__gmpz_array_init;}' unless defined(&mpz_array_init);
    eval 'sub mpz_bin_ui () { &__gmpz_bin_ui;}' unless defined(&mpz_bin_ui);
    eval 'sub mpz_bin_uiui () { &__gmpz_bin_uiui;}' unless defined(&mpz_bin_uiui);
    eval 'sub mpz_cdiv_q () { &__gmpz_cdiv_q;}' unless defined(&mpz_cdiv_q);
    eval 'sub mpz_cdiv_q_2exp () { &__gmpz_cdiv_q_2exp;}' unless defined(&mpz_cdiv_q_2exp);
    eval 'sub mpz_cdiv_q_ui () { &__gmpz_cdiv_q_ui;}' unless defined(&mpz_cdiv_q_ui);
    eval 'sub mpz_cdiv_qr () { &__gmpz_cdiv_qr;}' unless defined(&mpz_cdiv_qr);
    eval 'sub mpz_cdiv_qr_ui () { &__gmpz_cdiv_qr_ui;}' unless defined(&mpz_cdiv_qr_ui);
    eval 'sub mpz_cdiv_r () { &__gmpz_cdiv_r;}' unless defined(&mpz_cdiv_r);
    eval 'sub mpz_cdiv_r_2exp () { &__gmpz_cdiv_r_2exp;}' unless defined(&mpz_cdiv_r_2exp);
    eval 'sub mpz_cdiv_r_ui () { &__gmpz_cdiv_r_ui;}' unless defined(&mpz_cdiv_r_ui);
    eval 'sub mpz_cdiv_ui () { &__gmpz_cdiv_ui;}' unless defined(&mpz_cdiv_ui);
    eval 'sub mpz_clear () { &__gmpz_clear;}' unless defined(&mpz_clear);
    eval 'sub mpz_clrbit () { &__gmpz_clrbit;}' unless defined(&mpz_clrbit);
    eval 'sub mpz_cmp () { &__gmpz_cmp;}' unless defined(&mpz_cmp);
    eval 'sub mpz_cmp_d () { &__gmpz_cmp_d;}' unless defined(&mpz_cmp_d);
    eval 'sub _mpz_cmp_si () { &__gmpz_cmp_si;}' unless defined(&_mpz_cmp_si);
    eval 'sub _mpz_cmp_ui () { &__gmpz_cmp_ui;}' unless defined(&_mpz_cmp_ui);
    eval 'sub mpz_cmpabs () { &__gmpz_cmpabs;}' unless defined(&mpz_cmpabs);
    eval 'sub mpz_cmpabs_d () { &__gmpz_cmpabs_d;}' unless defined(&mpz_cmpabs_d);
    eval 'sub mpz_cmpabs_ui () { &__gmpz_cmpabs_ui;}' unless defined(&mpz_cmpabs_ui);
    eval 'sub mpz_com () { &__gmpz_com;}' unless defined(&mpz_com);
    eval 'sub mpz_combit () { &__gmpz_combit;}' unless defined(&mpz_combit);
    eval 'sub mpz_congruent_p () { &__gmpz_congruent_p;}' unless defined(&mpz_congruent_p);
    eval 'sub mpz_congruent_2exp_p () { &__gmpz_congruent_2exp_p;}' unless defined(&mpz_congruent_2exp_p);
    eval 'sub mpz_congruent_ui_p () { &__gmpz_congruent_ui_p;}' unless defined(&mpz_congruent_ui_p);
    eval 'sub mpz_divexact () { &__gmpz_divexact;}' unless defined(&mpz_divexact);
    eval 'sub mpz_divexact_ui () { &__gmpz_divexact_ui;}' unless defined(&mpz_divexact_ui);
    eval 'sub mpz_divisible_p () { &__gmpz_divisible_p;}' unless defined(&mpz_divisible_p);
    eval 'sub mpz_divisible_ui_p () { &__gmpz_divisible_ui_p;}' unless defined(&mpz_divisible_ui_p);
    eval 'sub mpz_divisible_2exp_p () { &__gmpz_divisible_2exp_p;}' unless defined(&mpz_divisible_2exp_p);
    eval 'sub mpz_dump () { &__gmpz_dump;}' unless defined(&mpz_dump);
    eval 'sub mpz_export () { &__gmpz_export;}' unless defined(&mpz_export);
    eval 'sub mpz_fac_ui () { &__gmpz_fac_ui;}' unless defined(&mpz_fac_ui);
    eval 'sub mpz_fdiv_q () { &__gmpz_fdiv_q;}' unless defined(&mpz_fdiv_q);
    eval 'sub mpz_fdiv_q_2exp () { &__gmpz_fdiv_q_2exp;}' unless defined(&mpz_fdiv_q_2exp);
    eval 'sub mpz_fdiv_q_ui () { &__gmpz_fdiv_q_ui;}' unless defined(&mpz_fdiv_q_ui);
    eval 'sub mpz_fdiv_qr () { &__gmpz_fdiv_qr;}' unless defined(&mpz_fdiv_qr);
    eval 'sub mpz_fdiv_qr_ui () { &__gmpz_fdiv_qr_ui;}' unless defined(&mpz_fdiv_qr_ui);
    eval 'sub mpz_fdiv_r () { &__gmpz_fdiv_r;}' unless defined(&mpz_fdiv_r);
    eval 'sub mpz_fdiv_r_2exp () { &__gmpz_fdiv_r_2exp;}' unless defined(&mpz_fdiv_r_2exp);
    eval 'sub mpz_fdiv_r_ui () { &__gmpz_fdiv_r_ui;}' unless defined(&mpz_fdiv_r_ui);
    eval 'sub mpz_fdiv_ui () { &__gmpz_fdiv_ui;}' unless defined(&mpz_fdiv_ui);
    eval 'sub mpz_fib_ui () { &__gmpz_fib_ui;}' unless defined(&mpz_fib_ui);
    eval 'sub mpz_fib2_ui () { &__gmpz_fib2_ui;}' unless defined(&mpz_fib2_ui);
    eval 'sub mpz_fits_sint_p () { &__gmpz_fits_sint_p;}' unless defined(&mpz_fits_sint_p);
    eval 'sub mpz_fits_slong_p () {\'__gmpz_fits_slong_p\';}' unless defined(&mpz_fits_slong_p);
    eval 'sub mpz_fits_sshort_p () { &__gmpz_fits_sshort_p;}' unless defined(&mpz_fits_sshort_p);
    eval 'sub mpz_fits_uint_p () { &__gmpz_fits_uint_p;}' unless defined(&mpz_fits_uint_p);
    if((defined(&__GMP_INLINE_PROTOTYPES) ? &__GMP_INLINE_PROTOTYPES : 0) || defined ( &__GMP_FORCE_mpz_fits_uint_p)) {
    }
    eval 'sub mpz_fits_ulong_p () {\'__gmpz_fits_ulong_p\';}' unless defined(&mpz_fits_ulong_p);
    if((defined(&__GMP_INLINE_PROTOTYPES) ? &__GMP_INLINE_PROTOTYPES : 0) || defined ) {
    }
    eval 'sub mpz_fits_ushort_p () { &__gmpz_fits_ushort_p;}' unless defined(&mpz_fits_ushort_p);
    if((defined(&__GMP_INLINE_PROTOTYPES) ? &__GMP_INLINE_PROTOTYPES : 0) || defined ( &__GMP_FORCE_mpz_fits_ushort_p)) {
    }
    eval 'sub mpz_gcd () { &__gmpz_gcd;}' unless defined(&mpz_gcd);
    eval 'sub mpz_gcd_ui () { &__gmpz_gcd_ui;}' unless defined(&mpz_gcd_ui);
    eval 'sub mpz_gcdext () { &__gmpz_gcdext;}' unless defined(&mpz_gcdext);
    eval 'sub mpz_get_d () { &__gmpz_get_d;}' unless defined(&mpz_get_d);
    eval 'sub mpz_get_d_2exp () { &__gmpz_get_d_2exp;}' unless defined(&mpz_get_d_2exp);
    eval 'sub mpz_get_si () { &__gmpz_get_si;}' unless defined(&mpz_get_si);
    eval 'sub mpz_get_str () { &__gmpz_get_str;}' unless defined(&mpz_get_str);
    eval 'sub mpz_get_ui () { &__gmpz_get_ui;}' unless defined(&mpz_get_ui);
    if((defined(&__GMP_INLINE_PROTOTYPES) ? &__GMP_INLINE_PROTOTYPES : 0) || defined ( &__GMP_FORCE_mpz_get_ui)) {
    }
    eval 'sub mpz_getlimbn () { &__gmpz_getlimbn;}' unless defined(&mpz_getlimbn);
    if((defined(&__GMP_INLINE_PROTOTYPES) ? &__GMP_INLINE_PROTOTYPES : 0) || defined ( &__GMP_FORCE_mpz_getlimbn)) {
    }
    eval 'sub mpz_hamdist () { &__gmpz_hamdist;}' unless defined(&mpz_hamdist);
    eval 'sub mpz_import () { &__gmpz_import;}' unless defined(&mpz_import);
    eval 'sub mpz_init () { &__gmpz_init;}' unless defined(&mpz_init);
    eval 'sub mpz_init2 () { &__gmpz_init2;}' unless defined(&mpz_init2);
    eval 'sub mpz_init_set () { &__gmpz_init_set;}' unless defined(&mpz_init_set);
    eval 'sub mpz_init_set_d () { &__gmpz_init_set_d;}' unless defined(&mpz_init_set_d);
    eval 'sub mpz_init_set_si () { &__gmpz_init_set_si;}' unless defined(&mpz_init_set_si);
    eval 'sub mpz_init_set_str () { &__gmpz_init_set_str;}' unless defined(&mpz_init_set_str);
    eval 'sub mpz_init_set_ui () { &__gmpz_init_set_ui;}' unless defined(&mpz_init_set_ui);
    eval 'sub mpz_inp_raw () { &__gmpz_inp_raw;}' unless defined(&mpz_inp_raw);
    if(defined(&_GMP_H_HAVE_FILE)) {
    }
    eval 'sub mpz_inp_str () { &__gmpz_inp_str;}' unless defined(&mpz_inp_str);
    if(defined(&_GMP_H_HAVE_FILE)) {
    }
    eval 'sub mpz_invert () { &__gmpz_invert;}' unless defined(&mpz_invert);
    eval 'sub mpz_ior () { &__gmpz_ior;}' unless defined(&mpz_ior);
    eval 'sub mpz_jacobi () { &__gmpz_jacobi;}' unless defined(&mpz_jacobi);
    eval 'sub mpz_kronecker () { &mpz_jacobi;}' unless defined(&mpz_kronecker);
    eval 'sub mpz_kronecker_si () { &__gmpz_kronecker_si;}' unless defined(&mpz_kronecker_si);
    eval 'sub mpz_kronecker_ui () { &__gmpz_kronecker_ui;}' unless defined(&mpz_kronecker_ui);
    eval 'sub mpz_si_kronecker () { &__gmpz_si_kronecker;}' unless defined(&mpz_si_kronecker);
    eval 'sub mpz_ui_kronecker () { &__gmpz_ui_kronecker;}' unless defined(&mpz_ui_kronecker);
    eval 'sub mpz_lcm () { &__gmpz_lcm;}' unless defined(&mpz_lcm);
    eval 'sub mpz_lcm_ui () { &__gmpz_lcm_ui;}' unless defined(&mpz_lcm_ui);
    eval 'sub mpz_legendre () { &mpz_jacobi;}' unless defined(&mpz_legendre);
    eval 'sub mpz_lucnum_ui () { &__gmpz_lucnum_ui;}' unless defined(&mpz_lucnum_ui);
    eval 'sub mpz_lucnum2_ui () { &__gmpz_lucnum2_ui;}' unless defined(&mpz_lucnum2_ui);
    eval 'sub mpz_millerrabin () { &__gmpz_millerrabin;}' unless defined(&mpz_millerrabin);
    eval 'sub mpz_mod () { &__gmpz_mod;}' unless defined(&mpz_mod);
    eval 'sub mpz_mod_ui () { &mpz_fdiv_r_ui;}' unless defined(&mpz_mod_ui);
    eval 'sub mpz_mul () { &__gmpz_mul;}' unless defined(&mpz_mul);
    eval 'sub mpz_mul_2exp () { &__gmpz_mul_2exp;}' unless defined(&mpz_mul_2exp);
    eval 'sub mpz_mul_si () { &__gmpz_mul_si;}' unless defined(&mpz_mul_si);
    eval 'sub mpz_mul_ui () { &__gmpz_mul_ui;}' unless defined(&mpz_mul_ui);
    eval 'sub mpz_neg () { &__gmpz_neg;}' unless defined(&mpz_neg);
    if((defined(&__GMP_INLINE_PROTOTYPES) ? &__GMP_INLINE_PROTOTYPES : 0) || defined ( &__GMP_FORCE_mpz_neg)) {
    }
    eval 'sub mpz_nextprime () { &__gmpz_nextprime;}' unless defined(&mpz_nextprime);
    eval 'sub mpz_out_raw () { &__gmpz_out_raw;}' unless defined(&mpz_out_raw);
    if(defined(&_GMP_H_HAVE_FILE)) {
    }
    eval 'sub mpz_out_str () { &__gmpz_out_str;}' unless defined(&mpz_out_str);
    if(defined(&_GMP_H_HAVE_FILE)) {
    }
    eval 'sub mpz_perfect_power_p () { &__gmpz_perfect_power_p;}' unless defined(&mpz_perfect_power_p);
    eval 'sub mpz_perfect_square_p () { &__gmpz_perfect_square_p;}' unless defined(&mpz_perfect_square_p);
    if((defined(&__GMP_INLINE_PROTOTYPES) ? &__GMP_INLINE_PROTOTYPES : 0) || defined ( &__GMP_FORCE_mpz_perfect_square_p)) {
    }
    eval 'sub mpz_popcount () { &__gmpz_popcount;}' unless defined(&mpz_popcount);
    if((defined(&__GMP_INLINE_PROTOTYPES) ? &__GMP_INLINE_PROTOTYPES : 0) || defined ( &__GMP_FORCE_mpz_popcount)) {
    }
    eval 'sub mpz_pow_ui () { &__gmpz_pow_ui;}' unless defined(&mpz_pow_ui);
    eval 'sub mpz_powm () { &__gmpz_powm;}' unless defined(&mpz_powm);
    eval 'sub mpz_powm_ui () { &__gmpz_powm_ui;}' unless defined(&mpz_powm_ui);
    eval 'sub mpz_probab_prime_p () { &__gmpz_probab_prime_p;}' unless defined(&mpz_probab_prime_p);
    eval 'sub mpz_random () { &__gmpz_random;}' unless defined(&mpz_random);
    eval 'sub mpz_random2 () { &__gmpz_random2;}' unless defined(&mpz_random2);
    eval 'sub mpz_realloc2 () { &__gmpz_realloc2;}' unless defined(&mpz_realloc2);
    eval 'sub mpz_remove () { &__gmpz_remove;}' unless defined(&mpz_remove);
    eval 'sub mpz_root () { &__gmpz_root;}' unless defined(&mpz_root);
    eval 'sub mpz_rootrem () { &__gmpz_rootrem;}' unless defined(&mpz_rootrem);
    eval 'sub mpz_rrandomb () { &__gmpz_rrandomb;}' unless defined(&mpz_rrandomb);
    eval 'sub mpz_scan0 () { &__gmpz_scan0;}' unless defined(&mpz_scan0);
    eval 'sub mpz_scan1 () { &__gmpz_scan1;}' unless defined(&mpz_scan1);
    eval 'sub mpz_set () { &__gmpz_set;}' unless defined(&mpz_set);
    eval 'sub mpz_set_d () { &__gmpz_set_d;}' unless defined(&mpz_set_d);
    eval 'sub mpz_set_f () { &__gmpz_set_f;}' unless defined(&mpz_set_f);
    eval 'sub mpz_set_q () { &__gmpz_set_q;}' unless defined(&mpz_set_q);
    if((defined(&__GMP_INLINE_PROTOTYPES) ? &__GMP_INLINE_PROTOTYPES : 0) || defined ( &__GMP_FORCE_mpz_set_q)) {
    }
    eval 'sub mpz_set_si () { &__gmpz_set_si;}' unless defined(&mpz_set_si);
    eval 'sub mpz_set_str () { &__gmpz_set_str;}' unless defined(&mpz_set_str);
    eval 'sub mpz_set_ui () { &__gmpz_set_ui;}' unless defined(&mpz_set_ui);
    eval 'sub mpz_setbit () { &__gmpz_setbit;}' unless defined(&mpz_setbit);
    eval 'sub mpz_size () { &__gmpz_size;}' unless defined(&mpz_size);
    if((defined(&__GMP_INLINE_PROTOTYPES) ? &__GMP_INLINE_PROTOTYPES : 0) || defined ( &__GMP_FORCE_mpz_size)) {
    }
    eval 'sub mpz_sizeinbase () { &__gmpz_sizeinbase;}' unless defined(&mpz_sizeinbase);
    eval 'sub mpz_sqrt () { &__gmpz_sqrt;}' unless defined(&mpz_sqrt);
    eval 'sub mpz_sqrtrem () { &__gmpz_sqrtrem;}' unless defined(&mpz_sqrtrem);
    eval 'sub mpz_sub () { &__gmpz_sub;}' unless defined(&mpz_sub);
    eval 'sub mpz_sub_ui () { &__gmpz_sub_ui;}' unless defined(&mpz_sub_ui);
    eval 'sub mpz_ui_sub () { &__gmpz_ui_sub;}' unless defined(&mpz_ui_sub);
    eval 'sub mpz_submul () { &__gmpz_submul;}' unless defined(&mpz_submul);
    eval 'sub mpz_submul_ui () { &__gmpz_submul_ui;}' unless defined(&mpz_submul_ui);
    eval 'sub mpz_swap () { &__gmpz_swap;}' unless defined(&mpz_swap);
    eval 'sub mpz_tdiv_ui () { &__gmpz_tdiv_ui;}' unless defined(&mpz_tdiv_ui);
    eval 'sub mpz_tdiv_q () { &__gmpz_tdiv_q;}' unless defined(&mpz_tdiv_q);
    eval 'sub mpz_tdiv_q_2exp () { &__gmpz_tdiv_q_2exp;}' unless defined(&mpz_tdiv_q_2exp);
    eval 'sub mpz_tdiv_q_ui () { &__gmpz_tdiv_q_ui;}' unless defined(&mpz_tdiv_q_ui);
    eval 'sub mpz_tdiv_qr () { &__gmpz_tdiv_qr;}' unless defined(&mpz_tdiv_qr);
    eval 'sub mpz_tdiv_qr_ui () { &__gmpz_tdiv_qr_ui;}' unless defined(&mpz_tdiv_qr_ui);
    eval 'sub mpz_tdiv_r () { &__gmpz_tdiv_r;}' unless defined(&mpz_tdiv_r);
    eval 'sub mpz_tdiv_r_2exp () { &__gmpz_tdiv_r_2exp;}' unless defined(&mpz_tdiv_r_2exp);
    eval 'sub mpz_tdiv_r_ui () { &__gmpz_tdiv_r_ui;}' unless defined(&mpz_tdiv_r_ui);
    eval 'sub mpz_tstbit () { &__gmpz_tstbit;}' unless defined(&mpz_tstbit);
    eval 'sub mpz_ui_pow_ui () { &__gmpz_ui_pow_ui;}' unless defined(&mpz_ui_pow_ui);
    eval 'sub mpz_urandomb () { &__gmpz_urandomb;}' unless defined(&mpz_urandomb);
    eval 'sub mpz_urandomm () { &__gmpz_urandomm;}' unless defined(&mpz_urandomm);
    eval 'sub mpz_xor () { &__gmpz_xor;}' unless defined(&mpz_xor);
    eval 'sub mpz_eor () { &__gmpz_xor;}' unless defined(&mpz_eor);
    eval 'sub mpq_abs () { &__gmpq_abs;}' unless defined(&mpq_abs);
    if((defined(&__GMP_INLINE_PROTOTYPES) ? &__GMP_INLINE_PROTOTYPES : 0) || defined ( &__GMP_FORCE_mpq_abs)) {
    }
    eval 'sub mpq_add () { &__gmpq_add;}' unless defined(&mpq_add);
    eval 'sub mpq_canonicalize () { &__gmpq_canonicalize;}' unless defined(&mpq_canonicalize);
    eval 'sub mpq_clear () { &__gmpq_clear;}' unless defined(&mpq_clear);
    eval 'sub mpq_cmp () { &__gmpq_cmp;}' unless defined(&mpq_cmp);
    eval 'sub _mpq_cmp_si () { &__gmpq_cmp_si;}' unless defined(&_mpq_cmp_si);
    eval 'sub _mpq_cmp_ui () { &__gmpq_cmp_ui;}' unless defined(&_mpq_cmp_ui);
    eval 'sub mpq_div () { &__gmpq_div;}' unless defined(&mpq_div);
    eval 'sub mpq_div_2exp () { &__gmpq_div_2exp;}' unless defined(&mpq_div_2exp);
    eval 'sub mpq_equal () { &__gmpq_equal;}' unless defined(&mpq_equal);
    eval 'sub mpq_get_num () { &__gmpq_get_num;}' unless defined(&mpq_get_num);
    eval 'sub mpq_get_den () { &__gmpq_get_den;}' unless defined(&mpq_get_den);
    eval 'sub mpq_get_d () { &__gmpq_get_d;}' unless defined(&mpq_get_d);
    eval 'sub mpq_get_str () { &__gmpq_get_str;}' unless defined(&mpq_get_str);
    eval 'sub mpq_init () { &__gmpq_init;}' unless defined(&mpq_init);
    eval 'sub mpq_inp_str () { &__gmpq_inp_str;}' unless defined(&mpq_inp_str);
    if(defined(&_GMP_H_HAVE_FILE)) {
    }
    eval 'sub mpq_inv () { &__gmpq_inv;}' unless defined(&mpq_inv);
    eval 'sub mpq_mul () { &__gmpq_mul;}' unless defined(&mpq_mul);
    eval 'sub mpq_mul_2exp () { &__gmpq_mul_2exp;}' unless defined(&mpq_mul_2exp);
    eval 'sub mpq_neg () { &__gmpq_neg;}' unless defined(&mpq_neg);
    if((defined(&__GMP_INLINE_PROTOTYPES) ? &__GMP_INLINE_PROTOTYPES : 0) || defined ( &__GMP_FORCE_mpq_neg)) {
    }
    eval 'sub mpq_out_str () { &__gmpq_out_str;}' unless defined(&mpq_out_str);
    if(defined(&_GMP_H_HAVE_FILE)) {
    }
    eval 'sub mpq_set () { &__gmpq_set;}' unless defined(&mpq_set);
    eval 'sub mpq_set_d () { &__gmpq_set_d;}' unless defined(&mpq_set_d);
    eval 'sub mpq_set_den () { &__gmpq_set_den;}' unless defined(&mpq_set_den);
    eval 'sub mpq_set_f () { &__gmpq_set_f;}' unless defined(&mpq_set_f);
    eval 'sub mpq_set_num () { &__gmpq_set_num;}' unless defined(&mpq_set_num);
    eval 'sub mpq_set_si () { &__gmpq_set_si;}' unless defined(&mpq_set_si);
    eval 'sub mpq_set_str () { &__gmpq_set_str;}' unless defined(&mpq_set_str);
    eval 'sub mpq_set_ui () { &__gmpq_set_ui;}' unless defined(&mpq_set_ui);
    eval 'sub mpq_set_z () { &__gmpq_set_z;}' unless defined(&mpq_set_z);
    eval 'sub mpq_sub () { &__gmpq_sub;}' unless defined(&mpq_sub);
    eval 'sub mpq_swap () { &__gmpq_swap;}' unless defined(&mpq_swap);
    eval 'sub mpf_abs () { &__gmpf_abs;}' unless defined(&mpf_abs);
    eval 'sub mpf_add () { &__gmpf_add;}' unless defined(&mpf_add);
    eval 'sub mpf_add_ui () { &__gmpf_add_ui;}' unless defined(&mpf_add_ui);
    eval 'sub mpf_ceil () { &__gmpf_ceil;}' unless defined(&mpf_ceil);
    eval 'sub mpf_clear () { &__gmpf_clear;}' unless defined(&mpf_clear);
    eval 'sub mpf_cmp () { &__gmpf_cmp;}' unless defined(&mpf_cmp);
    eval 'sub mpf_cmp_d () { &__gmpf_cmp_d;}' unless defined(&mpf_cmp_d);
    eval 'sub mpf_cmp_si () { &__gmpf_cmp_si;}' unless defined(&mpf_cmp_si);
    eval 'sub mpf_cmp_ui () { &__gmpf_cmp_ui;}' unless defined(&mpf_cmp_ui);
    eval 'sub mpf_div () { &__gmpf_div;}' unless defined(&mpf_div);
    eval 'sub mpf_div_2exp () { &__gmpf_div_2exp;}' unless defined(&mpf_div_2exp);
    eval 'sub mpf_div_ui () { &__gmpf_div_ui;}' unless defined(&mpf_div_ui);
    eval 'sub mpf_dump () { &__gmpf_dump;}' unless defined(&mpf_dump);
    eval 'sub mpf_eq () { &__gmpf_eq;}' unless defined(&mpf_eq);
    eval 'sub mpf_fits_sint_p () { &__gmpf_fits_sint_p;}' unless defined(&mpf_fits_sint_p);
    eval 'sub mpf_fits_slong_p () {\'__gmpf_fits_slong_p\';}' unless defined(&mpf_fits_slong_p);
    eval 'sub mpf_fits_sshort_p () { &__gmpf_fits_sshort_p;}' unless defined(&mpf_fits_sshort_p);
    eval 'sub mpf_fits_uint_p () { &__gmpf_fits_uint_p;}' unless defined(&mpf_fits_uint_p);
    eval 'sub mpf_fits_ulong_p () {\'__gmpf_fits_ulong_p\';}' unless defined(&mpf_fits_ulong_p);
    eval 'sub mpf_fits_ushort_p () { &__gmpf_fits_ushort_p;}' unless defined(&mpf_fits_ushort_p);
    eval 'sub mpf_floor () { &__gmpf_floor;}' unless defined(&mpf_floor);
    eval 'sub mpf_get_d () { &__gmpf_get_d;}' unless defined(&mpf_get_d);
    eval 'sub mpf_get_d_2exp () { &__gmpf_get_d_2exp;}' unless defined(&mpf_get_d_2exp);
    eval 'sub mpf_get_default_prec () { &__gmpf_get_default_prec;}' unless defined(&mpf_get_default_prec);
    eval 'sub mpf_get_prec () { &__gmpf_get_prec;}' unless defined(&mpf_get_prec);
    eval 'sub mpf_get_si () { &__gmpf_get_si;}' unless defined(&mpf_get_si);
    eval 'sub mpf_get_str () { &__gmpf_get_str;}' unless defined(&mpf_get_str);
    eval 'sub mpf_get_ui () { &__gmpf_get_ui;}' unless defined(&mpf_get_ui);
    eval 'sub mpf_init () { &__gmpf_init;}' unless defined(&mpf_init);
    eval 'sub mpf_init2 () { &__gmpf_init2;}' unless defined(&mpf_init2);
    eval 'sub mpf_init_set () { &__gmpf_init_set;}' unless defined(&mpf_init_set);
    eval 'sub mpf_init_set_d () { &__gmpf_init_set_d;}' unless defined(&mpf_init_set_d);
    eval 'sub mpf_init_set_si () { &__gmpf_init_set_si;}' unless defined(&mpf_init_set_si);
    eval 'sub mpf_init_set_str () { &__gmpf_init_set_str;}' unless defined(&mpf_init_set_str);
    eval 'sub mpf_init_set_ui () { &__gmpf_init_set_ui;}' unless defined(&mpf_init_set_ui);
    eval 'sub mpf_inp_str () { &__gmpf_inp_str;}' unless defined(&mpf_inp_str);
    if(defined(&_GMP_H_HAVE_FILE)) {
    }
    eval 'sub mpf_integer_p () { &__gmpf_integer_p;}' unless defined(&mpf_integer_p);
    eval 'sub mpf_mul () { &__gmpf_mul;}' unless defined(&mpf_mul);
    eval 'sub mpf_mul_2exp () { &__gmpf_mul_2exp;}' unless defined(&mpf_mul_2exp);
    eval 'sub mpf_mul_ui () { &__gmpf_mul_ui;}' unless defined(&mpf_mul_ui);
    eval 'sub mpf_neg () { &__gmpf_neg;}' unless defined(&mpf_neg);
    eval 'sub mpf_out_str () { &__gmpf_out_str;}' unless defined(&mpf_out_str);
    if(defined(&_GMP_H_HAVE_FILE)) {
    }
    eval 'sub mpf_pow_ui () { &__gmpf_pow_ui;}' unless defined(&mpf_pow_ui);
    eval 'sub mpf_random2 () { &__gmpf_random2;}' unless defined(&mpf_random2);
    eval 'sub mpf_reldiff () { &__gmpf_reldiff;}' unless defined(&mpf_reldiff);
    eval 'sub mpf_set () { &__gmpf_set;}' unless defined(&mpf_set);
    eval 'sub mpf_set_d () { &__gmpf_set_d;}' unless defined(&mpf_set_d);
    eval 'sub mpf_set_default_prec () { &__gmpf_set_default_prec;}' unless defined(&mpf_set_default_prec);
    eval 'sub mpf_set_prec () { &__gmpf_set_prec;}' unless defined(&mpf_set_prec);
    eval 'sub mpf_set_prec_raw () { &__gmpf_set_prec_raw;}' unless defined(&mpf_set_prec_raw);
    eval 'sub mpf_set_q () { &__gmpf_set_q;}' unless defined(&mpf_set_q);
    eval 'sub mpf_set_si () { &__gmpf_set_si;}' unless defined(&mpf_set_si);
    eval 'sub mpf_set_str () { &__gmpf_set_str;}' unless defined(&mpf_set_str);
    eval 'sub mpf_set_ui () { &__gmpf_set_ui;}' unless defined(&mpf_set_ui);
    eval 'sub mpf_set_z () { &__gmpf_set_z;}' unless defined(&mpf_set_z);
    eval 'sub mpf_size () { &__gmpf_size;}' unless defined(&mpf_size);
    eval 'sub mpf_sqrt () { &__gmpf_sqrt;}' unless defined(&mpf_sqrt);
    eval 'sub mpf_sqrt_ui () { &__gmpf_sqrt_ui;}' unless defined(&mpf_sqrt_ui);
    eval 'sub mpf_sub () { &__gmpf_sub;}' unless defined(&mpf_sub);
    eval 'sub mpf_sub_ui () { &__gmpf_sub_ui;}' unless defined(&mpf_sub_ui);
    eval 'sub mpf_swap () { &__gmpf_swap;}' unless defined(&mpf_swap);
    eval 'sub mpf_trunc () { &__gmpf_trunc;}' unless defined(&mpf_trunc);
    eval 'sub mpf_ui_div () { &__gmpf_ui_div;}' unless defined(&mpf_ui_div);
    eval 'sub mpf_ui_sub () { &__gmpf_ui_sub;}' unless defined(&mpf_ui_sub);
    eval 'sub mpf_urandomb () { &__gmpf_urandomb;}' unless defined(&mpf_urandomb);
    eval 'sub mpn_add () { &__MPN( &add);}' unless defined(&mpn_add);
    if((defined(&__GMP_INLINE_PROTOTYPES) ? &__GMP_INLINE_PROTOTYPES : 0) || defined ( &__GMP_FORCE_mpn_add)) {
    }
    eval 'sub mpn_add_1 () { &__MPN( &add_1);}' unless defined(&mpn_add_1);
    if((defined(&__GMP_INLINE_PROTOTYPES) ? &__GMP_INLINE_PROTOTYPES : 0) || defined ( &__GMP_FORCE_mpn_add_1)) {
    }
    eval 'sub mpn_add_n () { &__MPN( &add_n);}' unless defined(&mpn_add_n);
    eval 'sub mpn_addmul_1 () { &__MPN( &addmul_1);}' unless defined(&mpn_addmul_1);
    eval 'sub mpn_bdivmod () { &__MPN( &bdivmod);}' unless defined(&mpn_bdivmod);
    eval 'sub mpn_cmp () { &__MPN( &cmp);}' unless defined(&mpn_cmp);
    if((defined(&__GMP_INLINE_PROTOTYPES) ? &__GMP_INLINE_PROTOTYPES : 0) || defined ( &__GMP_FORCE_mpn_cmp)) {
    }
    eval 'sub mpn_divexact_by3 {
        my($dst,$src,$size) = @_;
	    eval q( &mpn_divexact_by3c ($dst, $src, $size,  &__GMP_CAST ( &mp_limb_t, 0)));
    }' unless defined(&mpn_divexact_by3);
    eval 'sub mpn_divexact_by3c () { &__MPN( &divexact_by3c);}' unless defined(&mpn_divexact_by3c);
    eval 'sub mpn_divmod_1 {
        my($qp,$np,$nsize,$dlimb) = @_;
	    eval q( &mpn_divrem_1 ($qp,  &__GMP_CAST ( &mp_size_t, 0), $np, $nsize, $dlimb));
    }' unless defined(&mpn_divmod_1);
    eval 'sub mpn_divrem () { &__MPN( &divrem);}' unless defined(&mpn_divrem);
    eval 'sub mpn_divrem_1 () { &__MPN( &divrem_1);}' unless defined(&mpn_divrem_1);
    eval 'sub mpn_divrem_2 () { &__MPN( &divrem_2);}' unless defined(&mpn_divrem_2);
    eval 'sub mpn_gcd () { &__MPN( &gcd);}' unless defined(&mpn_gcd);
    eval 'sub mpn_gcd_1 () { &__MPN( &gcd_1);}' unless defined(&mpn_gcd_1);
    eval 'sub mpn_gcdext () { &__MPN( &gcdext);}' unless defined(&mpn_gcdext);
    eval 'sub mpn_get_str () { &__MPN( &get_str);}' unless defined(&mpn_get_str);
    eval 'sub mpn_hamdist () { &__MPN( &hamdist);}' unless defined(&mpn_hamdist);
    eval 'sub mpn_lshift () { &__MPN( &lshift);}' unless defined(&mpn_lshift);
    eval 'sub mpn_mod_1 () { &__MPN( &mod_1);}' unless defined(&mpn_mod_1);
    eval 'sub mpn_mul () { &__MPN( &mul);}' unless defined(&mpn_mul);
    eval 'sub mpn_mul_1 () { &__MPN( &mul_1);}' unless defined(&mpn_mul_1);
    eval 'sub mpn_mul_n () { &__MPN( &mul_n);}' unless defined(&mpn_mul_n);
    eval 'sub mpn_perfect_square_p () { &__MPN( &perfect_square_p);}' unless defined(&mpn_perfect_square_p);
    eval 'sub mpn_popcount () { &__MPN( &popcount);}' unless defined(&mpn_popcount);
    eval 'sub mpn_pow_1 () { &__MPN( &pow_1);}' unless defined(&mpn_pow_1);
    eval 'sub mpn_preinv_mod_1 () { &__MPN( &preinv_mod_1);}' unless defined(&mpn_preinv_mod_1);
    eval 'sub mpn_random () { &__MPN( &random);}' unless defined(&mpn_random);
    eval 'sub mpn_random2 () { &__MPN( &random2);}' unless defined(&mpn_random2);
    eval 'sub mpn_rshift () { &__MPN( &rshift);}' unless defined(&mpn_rshift);
    eval 'sub mpn_scan0 () { &__MPN( &scan0);}' unless defined(&mpn_scan0);
    eval 'sub mpn_scan1 () { &__MPN( &scan1);}' unless defined(&mpn_scan1);
    eval 'sub mpn_set_str () { &__MPN( &set_str);}' unless defined(&mpn_set_str);
    eval 'sub mpn_sqrtrem () { &__MPN( &sqrtrem);}' unless defined(&mpn_sqrtrem);
    eval 'sub mpn_sub () { &__MPN( &sub);}' unless defined(&mpn_sub);
    if((defined(&__GMP_INLINE_PROTOTYPES) ? &__GMP_INLINE_PROTOTYPES : 0) || defined ( &__GMP_FORCE_mpn_sub)) {
    }
    eval 'sub mpn_sub_1 () { &__MPN( &sub_1);}' unless defined(&mpn_sub_1);
    if((defined(&__GMP_INLINE_PROTOTYPES) ? &__GMP_INLINE_PROTOTYPES : 0) || defined ( &__GMP_FORCE_mpn_sub_1)) {
    }
    eval 'sub mpn_sub_n () { &__MPN( &sub_n);}' unless defined(&mpn_sub_n);
    eval 'sub mpn_submul_1 () { &__MPN( &submul_1);}' unless defined(&mpn_submul_1);
    eval 'sub mpn_tdiv_qr () { &__MPN( &tdiv_qr);}' unless defined(&mpn_tdiv_qr);
    if(defined ( &__GMP_EXTERN_INLINE)  && ! defined ( &__GMP_FORCE_mpz_abs)) {
    }
    if((defined(&GMP_NAIL_BITS) ? &GMP_NAIL_BITS : 0) == 0) {
	eval 'sub __GMPZ_FITS_UTYPE_P {
	    my($z,$maxval) = @_;
    	    eval q( &mp_size_t  &__gmp_n =  ($z->{_mp_size});  &mp_ptr  &__gmp_p =  ($z->{_mp_d});  &return ( &__gmp_n == 0|| ( &__gmp_n == 1 &&  $__gmp_p[0] <= $maxval)););
	}' unless defined(&__GMPZ_FITS_UTYPE_P);
    } else {
	eval 'sub __GMPZ_FITS_UTYPE_P {
	    my($z,$maxval) = @_;
    	    eval q( &mp_size_t  &__gmp_n =  ($z->{_mp_size});  &mp_ptr  &__gmp_p =  ($z->{_mp_d});  &return ( &__gmp_n == 0|| ( &__gmp_n == 1 &&  $__gmp_p[0] <= $maxval) || ( &__gmp_n == 2 &&  $__gmp_p[1] <= (( &mp_limb_t) $maxval >>  &GMP_NUMB_BITS))););
	}' unless defined(&__GMPZ_FITS_UTYPE_P);
    }
    if(defined ( &__GMP_EXTERN_INLINE) || defined ( &__GMP_FORCE_mpz_fits_uint_p)) {
	if(! defined ( &__GMP_FORCE_mpz_fits_uint_p)) {
	}
    }
    if(defined ( &__GMP_EXTERN_INLINE) || defined ) {
	if(! defined ) {
	}
    }
    if(defined ( &__GMP_EXTERN_INLINE) || defined ( &__GMP_FORCE_mpz_fits_ushort_p)) {
	if(! defined ( &__GMP_FORCE_mpz_fits_ushort_p)) {
	}
    }
    if(defined ( &__GMP_EXTERN_INLINE) || defined ( &__GMP_FORCE_mpz_get_ui)) {
	if(! defined ( &__GMP_FORCE_mpz_get_ui)) {
	}
	if((defined(&GMP_NAIL_BITS) ? &GMP_NAIL_BITS : 0) == 0|| defined ( &_LONG_LONG_LIMB)) {
	} else {
	}
    }
    if(defined ( &__GMP_EXTERN_INLINE) || defined ( &__GMP_FORCE_mpz_getlimbn)) {
	if(! defined ( &__GMP_FORCE_mpz_getlimbn)) {
	}
    }
    if(defined ( &__GMP_EXTERN_INLINE)  && ! defined ( &__GMP_FORCE_mpz_neg)) {
    }
    if(defined ( &__GMP_EXTERN_INLINE) || defined ( &__GMP_FORCE_mpz_perfect_square_p)) {
	if(! defined ( &__GMP_FORCE_mpz_perfect_square_p)) {
	}
    }
    if(defined ( &__GMP_EXTERN_INLINE) || defined ( &__GMP_FORCE_mpz_popcount)) {
	if(! defined ( &__GMP_FORCE_mpz_popcount)) {
	}
    }
    if(defined ( &__GMP_EXTERN_INLINE) || defined ( &__GMP_FORCE_mpz_set_q)) {
	if(! defined ( &__GMP_FORCE_mpz_set_q)) {
	}
    }
    if(defined ( &__GMP_EXTERN_INLINE) || defined ( &__GMP_FORCE_mpz_size)) {
	if(! defined ( &__GMP_FORCE_mpz_size)) {
	}
    }
    if(defined ( &__GMP_EXTERN_INLINE)  && ! defined ( &__GMP_FORCE_mpq_abs)) {
    }
    if(defined ( &__GMP_EXTERN_INLINE)  && ! defined ( &__GMP_FORCE_mpq_neg)) {
    }
    eval 'sub __GMPN_AORS {
        my($cout, $wp, $xp, $xsize, $yp, $ysize, $FUNCTION, $TEST) = @_;
	    eval q( &do {  &mp_size_t  &__gmp_i;  &mp_limb_t  &__gmp_x;  &__gmp_i = ($ysize);  &if ( &__gmp_i != 0) {  &if ($FUNCTION ($wp, $xp, $yp,  &__gmp_i)) {  &do {  &if ( &__gmp_i >= ($xsize)) { ($cout) = 1;  &goto  &__gmp_done; }  &__gmp_x = ($xp)[ &__gmp_i]; }  &while ($TEST); } }  &if (($wp) != ($xp))  &__GMPN_COPY_REST ($wp, $xp, $xsize,  &__gmp_i); ($cout) = 0;  &__gmp_done: ; }  &while (0));
    }' unless defined(&__GMPN_AORS);
    eval 'sub __GMPN_ADD {
        my($cout, $wp, $xp, $xsize, $yp, $ysize) = @_;
	    eval q( &__GMPN_AORS ($cout, $wp, $xp, $xsize, $yp, $ysize,  &mpn_add_n, ((($wp)[ &__gmp_i++] = ( &__gmp_x + 1) &  &GMP_NUMB_MASK) == 0)));
    }' unless defined(&__GMPN_ADD);
    eval 'sub __GMPN_SUB {
        my($cout, $wp, $xp, $xsize, $yp, $ysize) = @_;
	    eval q( &__GMPN_AORS ($cout, $wp, $xp, $xsize, $yp, $ysize,  &mpn_sub_n, ((($wp)[ &__gmp_i++] = ( &__gmp_x - 1) &  &GMP_NUMB_MASK),  &__gmp_x == 0)));
    }' unless defined(&__GMPN_SUB);
    if((defined(&GMP_NAIL_BITS) ? &GMP_NAIL_BITS : 0) == 0) {
	eval 'sub __GMPN_AORS_1 {
	    my($cout, $dst, $src, $n, $v, $OP, $CB) = @_;
    	    eval q( &do {  &mp_size_t  &__gmp_i;  &mp_limb_t  &__gmp_x,  &__gmp_r;  &__gmp_x = ($src)[0];  &__gmp_r =  &__gmp_x $OP ($v); ($dst)[0] =  &__gmp_r;  &if ($CB ( &__gmp_r,  &__gmp_x, ($v))) { ($cout) = 1;  &for ( &__gmp_i = 1;  &__gmp_i < ($n);) {  &__gmp_x = ($src)[ &__gmp_i];  &__gmp_r =  &__gmp_x $OP 1; ($dst)[ &__gmp_i] =  &__gmp_r; ++ &__gmp_i;  &if (!$CB ( &__gmp_r,  &__gmp_x, 1)) {  &if (($src) != ($dst))  &__GMPN_COPY_REST ($dst, $src, $n,  &__gmp_i); ($cout) = 0;  &break; } } }  &else {  &if (($src) != ($dst))  &__GMPN_COPY_REST ($dst, $src, $n, 1); ($cout) = 0; } }  &while (0));
	}' unless defined(&__GMPN_AORS_1);
    }
    if((defined(&GMP_NAIL_BITS) ? &GMP_NAIL_BITS : 0) >= 1) {
	eval 'sub __GMPN_AORS_1 {
	    my($cout, $dst, $src, $n, $v, $OP, $CB) = @_;
    	    eval q( &do {  &mp_size_t  &__gmp_i;  &mp_limb_t  &__gmp_x,  &__gmp_r;  &__gmp_x = ($src)[0];  &__gmp_r =  &__gmp_x $OP ($v); ($dst)[0] =  &__gmp_r &  &GMP_NUMB_MASK;  &if ( &__gmp_r >>  &GMP_NUMB_BITS != 0) { ($cout) = 1;  &for ( &__gmp_i = 1;  &__gmp_i < ($n);) {  &__gmp_x = ($src)[ &__gmp_i];  &__gmp_r =  &__gmp_x $OP 1; ($dst)[ &__gmp_i] =  &__gmp_r &  &GMP_NUMB_MASK; ++ &__gmp_i;  &if ( &__gmp_r >>  &GMP_NUMB_BITS == 0) {  &if (($src) != ($dst))  &__GMPN_COPY_REST ($dst, $src, $n,  &__gmp_i); ($cout) = 0;  &break; } } }  &else {  &if (($src) != ($dst))  &__GMPN_COPY_REST ($dst, $src, $n, 1); ($cout) = 0; } }  &while (0));
	}' unless defined(&__GMPN_AORS_1);
    }
    eval 'sub __GMPN_ADDCB {
        my($r,$x,$y) = @_;
	    eval q((($r) < ($y)));
    }' unless defined(&__GMPN_ADDCB);
    eval 'sub __GMPN_SUBCB {
        my($r,$x,$y) = @_;
	    eval q((($x) < ($y)));
    }' unless defined(&__GMPN_SUBCB);
    eval 'sub __GMPN_ADD_1 {
        my($cout, $dst, $src, $n, $v) = @_;
	    eval q( &__GMPN_AORS_1($cout, $dst, $src, $n, $v, +,  &__GMPN_ADDCB));
    }' unless defined(&__GMPN_ADD_1);
    eval 'sub __GMPN_SUB_1 {
        my($cout, $dst, $src, $n, $v) = @_;
	    eval q( &__GMPN_AORS_1($cout, $dst, $src, $n, $v, -,  &__GMPN_SUBCB));
    }' unless defined(&__GMPN_SUB_1);
    eval 'sub __GMPN_CMP {
        my($result, $xp, $yp, $size) = @_;
	    eval q( &do {  &mp_size_t  &__gmp_i;  &mp_limb_t  &__gmp_x,  &__gmp_y; ($result) = 0;  &__gmp_i = ($size);  &while (-- &__gmp_i >= 0) {  &__gmp_x = ($xp)[ &__gmp_i];  &__gmp_y = ($yp)[ &__gmp_i];  &if ( &__gmp_x !=  &__gmp_y) { ($result) = ( &__gmp_x >  &__gmp_y ? 1: -1);  &break; } } }  &while (0));
    }' unless defined(&__GMPN_CMP);
    if(defined ( &__GMPN_COPY)  && ! defined ( &__GMPN_COPY_REST)) {
	eval 'sub __GMPN_COPY_REST {
	    my($dst, $src, $size, $start) = @_;
    	    eval q( &do {  &__GMPN_COPY (($dst)+($start), ($src)+($start), ($size)-($start)); }  &while (0));
	}' unless defined(&__GMPN_COPY_REST);
    }
    if(! defined ( &__GMPN_COPY_REST)) {
	eval 'sub __GMPN_COPY_REST {
	    my($dst, $src, $size, $start) = @_;
    	    eval q( &do {  &mp_size_t  &__gmp_j;  &__GMP_CRAY_Pragma (\\"_CRI ivdep\\");  &for ( &__gmp_j = ($start);  &__gmp_j < ($size);  &__gmp_j++) ($dst)[ &__gmp_j] = ($src)[ &__gmp_j]; }  &while (0));
	}' unless defined(&__GMPN_COPY_REST);
    }
    if(! defined ( &__GMPN_COPY)) {
	eval 'sub __GMPN_COPY {
	    my($dst, $src, $size) = @_;
    	    eval q( &__GMPN_COPY_REST ($dst, $src, $size, 0));
	}' unless defined(&__GMPN_COPY);
    }
    if(defined ( &__GMP_EXTERN_INLINE) || defined ( &__GMP_FORCE_mpn_add)) {
	if(! defined ( &__GMP_FORCE_mpn_add)) {
	}
    }
    if(defined ( &__GMP_EXTERN_INLINE) || defined ( &__GMP_FORCE_mpn_add_1)) {
	if(! defined ( &__GMP_FORCE_mpn_add_1)) {
	}
    }
    if(defined ( &__GMP_EXTERN_INLINE) || defined ( &__GMP_FORCE_mpn_cmp)) {
	if(! defined ( &__GMP_FORCE_mpn_cmp)) {
	}
    }
    if(defined ( &__GMP_EXTERN_INLINE) || defined ( &__GMP_FORCE_mpn_sub)) {
	if(! defined ( &__GMP_FORCE_mpn_sub)) {
	}
    }
    if(defined ( &__GMP_EXTERN_INLINE) || defined ( &__GMP_FORCE_mpn_sub_1)) {
	if(! defined ( &__GMP_FORCE_mpn_sub_1)) {
	}
    }
    if(defined ( &__cplusplus)) {
    }
    eval 'sub mpz_sgn {
        my($Z) = @_;
	    eval q((($Z)-> &_mp_size < 0? -1: ($Z)-> &_mp_size > 0));
    }' unless defined(&mpz_sgn);
    eval 'sub mpf_sgn {
        my($F) = @_;
	    eval q((($F)-> &_mp_size < 0? -1: ($F)-> &_mp_size > 0));
    }' unless defined(&mpf_sgn);
    eval 'sub mpq_sgn {
        my($Q) = @_;
	    eval q((($Q)-> ($_mp_num->{_mp_size}) < 0? -1: ($Q)-> ($_mp_num->{_mp_size}) > 0));
    }' unless defined(&mpq_sgn);
    if(defined ( &__GNUC__)) {
	eval 'sub mpz_cmp_ui {
	    my($Z,$UI) = @_;
    	    eval q(( &__builtin_constant_p ($UI)  && ($UI) == 0?  &mpz_sgn ($Z) :  &_mpz_cmp_ui ($Z,$UI)));
	}' unless defined(&mpz_cmp_ui);
	eval 'sub mpz_cmp_si {
	    my($Z,$SI) = @_;
    	    eval q(( &__builtin_constant_p ($SI)  && ($SI) == 0?  &mpz_sgn ($Z) :  &__builtin_constant_p ($SI)  && ($SI) > 0?  &_mpz_cmp_ui ($Z,  &__GMP_CAST (\'unsigned long int\', $SI)) :  &_mpz_cmp_si ($Z,$SI)));
	}' unless defined(&mpz_cmp_si);
	eval 'sub mpq_cmp_ui {
	    my($Q,$NUI,$DUI) = @_;
    	    eval q(( &__builtin_constant_p ($NUI)  && ($NUI) == 0?  &mpq_sgn ($Q) :  &_mpq_cmp_ui ($Q,$NUI,$DUI)));
	}' unless defined(&mpq_cmp_ui);
	eval 'sub mpq_cmp_si {
	    my($q,$n,$d) = @_;
    	    eval q(( &__builtin_constant_p (($n) >= 0)  && ($n) >= 0?  &mpq_cmp_ui ($q,  &__GMP_CAST (\'unsigned long\', $n), $d) :  &_mpq_cmp_si ($q, $n, $d)));
	}' unless defined(&mpq_cmp_si);
    } else {
	eval 'sub mpz_cmp_ui {
	    my($Z,$UI) = @_;
    	    eval q( &_mpz_cmp_ui ($Z,$UI));
	}' unless defined(&mpz_cmp_ui);
	eval 'sub mpz_cmp_si {
	    my($Z,$UI) = @_;
    	    eval q( &_mpz_cmp_si ($Z,$UI));
	}' unless defined(&mpz_cmp_si);
	eval 'sub mpq_cmp_ui {
	    my($Q,$NUI,$DUI) = @_;
    	    eval q( &_mpq_cmp_ui ($Q,$NUI,$DUI));
	}' unless defined(&mpq_cmp_ui);
	eval 'sub mpq_cmp_si {
	    my($q,$n,$d) = @_;
    	    eval q( &_mpq_cmp_si($q,$n,$d));
	}' unless defined(&mpq_cmp_si);
    }
    eval 'sub mpz_odd_p {
        my($z) = @_;
	    eval q(((($z)-> &_mp_size != 0) &  &__GMP_CAST (\'int\', ($z)-> $_mp_d[0])));
    }' unless defined(&mpz_odd_p);
    eval 'sub mpz_even_p {
        my($z) = @_;
	    eval q((!  &mpz_odd_p ($z)));
    }' unless defined(&mpz_even_p);
    if(defined(&__cplusplus)) {
    }
    eval 'sub mpn_divmod {
        my($qp,$np,$nsize,$dp,$dsize) = @_;
	    eval q( &mpn_divrem ($qp,  &__GMP_CAST ( &mp_size_t, 0), $np, $nsize, $dp, $dsize));
    }' unless defined(&mpn_divmod);
    eval 'sub mpz_mdiv () { &mpz_fdiv_q;}' unless defined(&mpz_mdiv);
    eval 'sub mpz_mdivmod () { &mpz_fdiv_qr;}' unless defined(&mpz_mdivmod);
    eval 'sub mpz_mmod () { &mpz_fdiv_r;}' unless defined(&mpz_mmod);
    eval 'sub mpz_mdiv_ui () { &mpz_fdiv_q_ui;}' unless defined(&mpz_mdiv_ui);
    eval 'sub mpz_mdivmod_ui {
        my($q,$r,$n,$d) = @_;
	    eval q(((($r) == 0) ?  &mpz_fdiv_q_ui ($q,$n,$d) :  &mpz_fdiv_qr_ui ($q,$r,$n,$d)));
    }' unless defined(&mpz_mdivmod_ui);
    eval 'sub mpz_mmod_ui {
        my($r,$n,$d) = @_;
	    eval q(((($r) == 0) ?  &mpz_fdiv_ui ($n,$d) :  &mpz_fdiv_r_ui ($r,$n,$d)));
    }' unless defined(&mpz_mmod_ui);
    eval 'sub mpz_div () { &mpz_fdiv_q;}' unless defined(&mpz_div);
    eval 'sub mpz_divmod () { &mpz_fdiv_qr;}' unless defined(&mpz_divmod);
    eval 'sub mpz_div_ui () { &mpz_fdiv_q_ui;}' unless defined(&mpz_div_ui);
    eval 'sub mpz_divmod_ui () { &mpz_fdiv_qr_ui;}' unless defined(&mpz_divmod_ui);
    eval 'sub mpz_div_2exp () { &mpz_fdiv_q_2exp;}' unless defined(&mpz_div_2exp);
    eval 'sub mpz_mod_2exp () { &mpz_fdiv_r_2exp;}' unless defined(&mpz_mod_2exp);
    eval("sub GMP_ERROR_NONE () { 0; }") unless defined(&GMP_ERROR_NONE);
    eval("sub GMP_ERROR_UNSUPPORTED_ARGUMENT () { 1; }") unless defined(&GMP_ERROR_UNSUPPORTED_ARGUMENT);
    eval("sub GMP_ERROR_DIVISION_BY_ZERO () { 2; }") unless defined(&GMP_ERROR_DIVISION_BY_ZERO);
    eval("sub GMP_ERROR_SQRT_OF_NEGATIVE () { 4; }") unless defined(&GMP_ERROR_SQRT_OF_NEGATIVE);
    eval("sub GMP_ERROR_INVALID_ARGUMENT () { 8; }") unless defined(&GMP_ERROR_INVALID_ARGUMENT);
    eval 'sub __GNU_MP_VERSION () {4;}' unless defined(&__GNU_MP_VERSION);
    eval 'sub __GNU_MP_VERSION_MINOR () {2;}' unless defined(&__GNU_MP_VERSION_MINOR);
    eval 'sub __GNU_MP_VERSION_PATCHLEVEL () {2;}' unless defined(&__GNU_MP_VERSION_PATCHLEVEL);
    eval 'sub __GMP_H__ () {1;}' unless defined(&__GMP_H__);
}
1;
